;Program 4.3 packed BCD number Subtraction and Sddition.
;**************************************************************
;* FUNCTION: Test Two packed BCD returning a boolean Final_Result if the two BCD numbers are valid numbers
;*            then Subtract the first digits and add the second digits else ends
;* ENTRY : BCD1         in  F30h
;*		 : BCD2         in  F40h
;*		 : BCD_Result   in  F45h
;* EXIT  : if two Valid BCD numbers BCD_Result   in  F50h
;* ************************************************************

#include "P16F84A.inc"
; ----------------------------------------------------------
; Local equates for your own symbolic designators
; ----------------------------------------------------------
BCD    	        equ 20h	   ; The BCD number is in File 20h
Result      	equ 21h	   ; The result is in File 21h
Final_Result    equ 22h   ; The Final Packed BCD number result is in File 22h
	
; ----------------------------------------------------------
; General Purpose RAM Assignments
; ----------------------------------------------------------
			cblock 0x30
				BCD1    	    ; The First BCD number is in File 30h
				Final_Result1
			endc

			cblock 0x40
				BCD2 		    ; The Second BCD number is in File 40h
				Final_Result2
			endc

			cblock 0x45
                BCD_Result      ; The Final BCD number result is in File 50h
			endc
; ----------------------------------------------------------
; Macro Definitions
; ----------------------------------------------------------
BCD_Test	macro
			clrf Result		; Clear Result file 
			movf BCD,W		;
			iorlw 0xF0		; Mask the last four digits of the BCD File
			addlw 6 		; Add six
			btfsc STATUS,C  ; Needed IF produced a carry
			comf Result,F	; Make Result FF (Invalid BCD Number)
			nop
			nop	
			endm		
; ----------------------------------------------------------
; Vector definition
; ----------------------------------------------------------

			org 0x000
			nop
			goto Main
		
INT_Routine	org 0x004
			goto INT_Routine
; ----------------------------------------------------------
; The main Program
; ----------------------------------------------------------
Main		movf  BCD1,W
		movwf BCD
		call  Packed_Test		; Test the First Number
		movf  Final_Result,W
		movwf Final_Result1
		
		movf Final_Result1,F
		btfss STATUS,Z			; Test if valid First BCD continue else ends
		goto Finish

		movf  BCD2,W
		movwf BCD
		call  Packed_Test		; Test the Second Number
		movf  Final_Result,W
		movwf Final_Result2	
	
		movf Final_Result2,F
		btfss STATUS,Z			; Test if valid Second BCD continue else ends
		goto Finish

		movf BCD2,W
		xorlw 0x0F
		addwf BCD1,W			;BCD_ResultL = BCD1L - BCD2L 
		addlw 0xf1      		;BCD_ResultH = BCD1H + BCD2H
		movwf BCD_Result

     	goto Finish


; ----------------------------------------------------------
; Sub Routine Definitions
; ----------------------------------------------------------

Packed_Test
    	BCD_Test                ;Test the First Digit
    	movf Result,W
    	andlw 0x0F
    	movwf Final_Result		;Save the First digit result
    	swapf BCD,F
    	BCD_Test				;Test the Second Digit
    	swapf BCD,F			    
    	movf Result,W
    	andlw 0xF0
    	addwf Final_Result,F	;Save the Second digit result
	    nop
    	nop
        return	
; ----------------------------------------------------------
; The main Program end
; ----------------------------------------------------------		
Finish	
		END 
